第八周课程总结&实验报告(六)

实验六 Java异常

实验目的

理解异常的基本概念;

掌握异常处理方法及熟悉常见异常的捕获方法。

实验要求

练习捕获异常、声明异常、抛出异常的方法、熟悉try和catch子句的使用。

掌握自定义异常类的方法。

 实验内容

编写一个类,在其main()方法中创建一个一维数组,在try字句中访问数组元素,使其产生ArrayIndexOutOfBoundsException异常。在catch子句里捕获此异常对象,并且打印“数组越界”信息,加一个finally子句,打印一条信息以证明这里确实得到了执行。

自定义异常类的使用

实验代码:

 

public class Exception {
    public static void main(String[] args) {
        int a[] = {1,2,3,4,5,6};           
        try {
            for(int i=0;i<=6;i++) {
                System.out.println(a[i]);
            }
        }catch(ArrayIndexOutOfBoundsException e) {  
            e.getStackTrace();  
            System.out.println("越界数组");   
        }finally {
            System.out.println("程序已执行"); 
        }
    }

}

 

实验结果

分享图片

 

 

车站检查危险品的设备,如果发现危险品会发出警告。编程模拟设备发现危险品。

技术方案:

编写一个Exgeption的子类DangerException,该子类可以创建异常对象,该异常对象调用toShow()方法输出“危险物品”。编写一个Machine类,该类的方法checkBag(Goods goods)当发现参数goods是危险品时(goods的isDanger属性是true)将抛出DangerException异常。
程序在主类的main()方法中的try-catch语句的try部分让Machine类的实例调用checkBag(Goods goods)的方法,如果发现危险品就在try-catch语句的catch部分处理危险品。

运行代码:

    public class DangerException extends Exception{
        String things = "危险物品";
        public DangerException() {
        }
        public void toShow() {//输出危险物品
            System.out.println(things);
        }
}

public class Goods {
    public String name;
    public boolean flag;
    public String Dangerthings[] = {"刀具","火药","汽油","易燃易爆物品","枪支"};
    public Goods() {
    }
    public void setName(String name) {
        this.name = name;
    }
    public String getName() {
        return this.name;
    }
    public boolean isDanger() {
        for(int i=0;i<Dangerthings.length;i++) {
            if((this.name).equals(Dangerthings[i])) {
                this.flag = true;
                break;
            }
            else {
                this.flag = false;
            }
        }
        return this.flag;
    }
}
public class Machine {
    Goods goods = new Goods();
    public Machine() {
    }
    public void checkBag(Goods goods)throws DangerException{
        if(goods.isDanger()) {
            DangerException danger = new DangerException();
            throw danger;
        }
        else {
            System.out.println(goods.getName()+"不是危险物品");
        }
    }
}
public class 检查结果 {
        public static void main(String[] args) {
            Machine machine = new Machine();
            String name[] = {"西瓜","刀具","汽油","矿泉水","手机","衣服"};//输入需要检查的物品
            Goods  goods[] = new Goods[name.length];
            for(int i=0;i<name.length;i++) {
                goods[i] = new Goods();
                goods[i].setName(name[i]);
                try {
                    machine.checkBag(goods[i]);
                }
                catch(DangerException e){
                    System.out.print(name[i]+"是");
                    e.toShow();
                }
            }                                    
        }
}

运行结果:

 

分享图片

 

 实验总结
Throw:
作用在方法内,表示抛出具体异常,由方法体内的语句处理。
具体向外抛出的动作,所以它抛出的是一个异常实体类。若执行了Throw一定是抛出了某种异常。
Throws:
作用方法的声明上,如果抛出异常,则由该方法的调用者来进行异常处理。
主要的声明这个方法会抛出会抛出某种类型的异常,让它的使用者知道捕获异常的类型。
出现异常是一种可能性,但不一定会发生异常。

相关文章
相关标签/搜索